{
  "x-generator": "On Key REST API Docs Generator",
  "swagger": "2.0",
  "info": {
    "title": "On Key GEN  API Specification",
    "description": "Better and smarter enterprise asset management with one of the world's leading Enterprise Asset Management (EAM) systems.",
    "termsOfService": "https://www.onkey.com/",
    "contact": {
      "name": "On Key Support",
      "url": "https://www.onkey.com/",
      "email": "onkey.support@pragmaworld.net"
    },
    "license": {
      "name": "On Key Licence",
      "url": "https://www.onkey.com/"
    },
    "version": "1.0.0"
  },
  "host": "<variable>:443",
  "basePath": "/api/tenants/{client}/{connection}",
  "schemes": [
    "https"
  ],
  "consumes": [
    "application/vnd.onkey.entity+json",
    "application/vnd.onkey.entitypatch+json",
    "application/vnd.onkey.entitydelete+json",
    "application/vnd.onkey.entitycollection+json",
    "application/vnd.onkey.entitypatchcollection+json",
    "application/vnd.onkey.entitydeletecollection+json",
    "application/vnd.onkey.entitymatchupdatecollection+json",
    "multipart/form-data"
  ],
  "produces": [
    "application/vnd.onkey.entity+json",
    "application/vnd.onkey.notification+json",
    "application/vnd.onkey.entitycollectionpage+json",
    "application/vnd.onkey.entitycollection+json",
    "application/vnd.onkey.assetregistertreenode+json",
    "application/vnd.onkey.assetregistertreenodecollectionpage+json",
    "*/*"
  ],
  "paths": {
    "/Modules/GEN/AddressTypes/{id}": {
      "get": {
        "tags": [
          "Address Type"
        ],
        "summary": "Get a Address Type resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | AddressType->Code | string |  |\r\n| createdByUserId | AddressType->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | AddressType->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | AddressType->CreatedByUser_FullName | string |  |\r\n| createdOn | AddressType->CreatedOn | string | date-time |\r\n| isActive | AddressType->IsActive | boolean |  |\r\n| modifiedByUserId | AddressType->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | AddressType->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | AddressType->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | AddressType->ModifiedOn | string | date-time |\r\n| permissionTreeId | AddressType->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | AddressType->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | AddressType->PermissionTree_Description | string |  |\r\n| version | AddressType->Version | integer | int32 |\r\n| id | AddressType->Id | integer | int64 |\r\n| description | AddressType->Description | string |  |\r\n| notes | AddressType->Notes | string |  |\r\n| sequenceNumber | AddressType->SequenceNumber | integer | int32 |\r\n",
        "operationId": "GetAddressType",
        "produces": [
          "application/vnd.onkey.entity+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Address Type Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Address Type",
            "schema": {
              "$ref": "#/definitions/GetAddressTypeResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Address Type"
        ],
        "summary": "Update an existing Address Type resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | AddressType->Version | integer | int32 |\r\n| sequenceNumber | AddressType->SequenceNumber | integer | int32 |\r\n| code | AddressType->Code | string |  |\r\n| description | AddressType->Description | string |  |\r\n| notes | AddressType->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n\r\n",
        "operationId": "UpdateAddressType",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Address Type Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/UpdateAddressTypeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Address Type was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Address Type"
        ],
        "summary": "Delete an existing Address Type resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | AddressType->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "DeleteAddressType",
        "consumes": [
          "application/vnd.onkey.entitydelete+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Address Type Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "delete",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/DeleteAddressTypeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Address Type was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/AddressTypes": {
      "get": {
        "tags": [
          "Address Type"
        ],
        "summary": "Get a collection of Address Type resources.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | AddressType->Version | integer | int32 |\r\n| id | AddressType->Id | integer | int64 |\r\n| code | AddressType->Code | string |  |\r\n| description | AddressType->Description | string |  |\r\n| sequenceNumber | AddressType->SequenceNumber | integer | int32 |\r\n| notes | AddressType->Notes | string |  |\r\n| createdOn | AddressType->CreatedOn | string | date-time |\r\n| modifiedOn | AddressType->ModifiedOn | string | date-time |\r\n",
        "operationId": "GetAddressTypeCollection",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Address Type collection",
            "schema": {
              "$ref": "#/definitions/GetAddressTypeCollectionResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "post": {
        "tags": [
          "Address Type"
        ],
        "summary": "Create a new Address Type resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| permissionTreeId | AddressType->PermissionTree_Id | integer | int64 |\r\n| sequenceNumber | AddressType->SequenceNumber | integer | int32 |\r\n| code | AddressType->Code | string |  |\r\n| description | AddressType->Description | string |  |\r\n| notes | AddressType->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n\r\n",
        "operationId": "CreateAddressType",
        "consumes": [
          "application/vnd.onkey.entity+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "post",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/CreateAddressTypeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - resource was successfully created",
            "headers": {
              "OnKey-Resource-Id": {
                "type": "integer",
                "description": "Id of the resource created",
                "format": "Int64"
              },
              "OnKey-Resource-Location": {
                "type": "string",
                "description": "Uri to fetch the created resource"
              }
            }
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/AddressTypes/Lookups/LookupAddressTypeChangePermissionTree": {
      "get": {
        "tags": [
          "Address Type"
        ],
        "summary": "Lookup the permission set for changing the Address Type.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupAddressTypeChangePermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/AddressTypeChangePermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/AddressTypes/Lookups/LookupAddressTypeInsertPermissionTree": {
      "get": {
        "tags": [
          "Address Type"
        ],
        "summary": "Lookup the permission set for creating the Address Type.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupAddressTypeInsertPermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/AddressTypeInsertPermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/AddressTypes/Batch/{ids}": {
      "get": {
        "tags": [
          "Address Type"
        ],
        "summary": "Get a collection of Address Type resources for the set of id's.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | AddressType->Code | string |  |\r\n| createdByUserId | AddressType->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | AddressType->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | AddressType->CreatedByUser_FullName | string |  |\r\n| createdOn | AddressType->CreatedOn | string | date-time |\r\n| isActive | AddressType->IsActive | boolean |  |\r\n| modifiedByUserId | AddressType->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | AddressType->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | AddressType->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | AddressType->ModifiedOn | string | date-time |\r\n| permissionTreeId | AddressType->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | AddressType->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | AddressType->PermissionTree_Description | string |  |\r\n| version | AddressType->Version | integer | int32 |\r\n| id | AddressType->Id | integer | int64 |\r\n| description | AddressType->Description | string |  |\r\n| notes | AddressType->Notes | string |  |\r\n| sequenceNumber | AddressType->SequenceNumber | integer | int32 |\r\n",
        "operationId": "BatchGetAddressType",
        "produces": [
          "application/vnd.onkey.entitycollection+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "array",
            "name": "ids",
            "in": "path",
            "required": true,
            "description": "A comma separated list of Address Type id's (eg. 1585760985950002,1585760985950003)",
            "collectionFormat": "csv",
            "x-nullable": false,
            "items": {
              "type": "integer",
              "format": "int64"
            }
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Address Type collection",
            "schema": {
              "$ref": "#/definitions/BatchGetAddressTypeResourceAction"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/AddressTypes/Batch": {
      "post": {
        "tags": [
          "Address Type"
        ],
        "summary": "Create a new collection of Address Type resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| permissionTreeId | AddressType->PermissionTree_Id | integer | int64 |\r\n| sequenceNumber | AddressType->SequenceNumber | integer | int32 |\r\n| code | AddressType->Code | string |  |\r\n| description | AddressType->Description | string |  |\r\n| notes | AddressType->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n\r\n",
        "operationId": "BatchCreateAddressType",
        "consumes": [
          "application/vnd.onkey.entitycollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "posts",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchCreateAddressTypeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - Address Type batch was successfully created"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Address Type"
        ],
        "summary": "Update a collection of existing Address Type resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | AddressType->Id | integer | int64 |\r\n| version | AddressType->Version | integer | int32 |\r\n| sequenceNumber | AddressType->SequenceNumber | integer | int32 |\r\n| code | AddressType->Code | string |  |\r\n| description | AddressType->Description | string |  |\r\n| notes | AddressType->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n\r\n",
        "operationId": "BatchUpdateAddressType",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchUpdateAddressTypeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Address Type batch was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Address Type"
        ],
        "summary": "Delete a collection of existing Address Type resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | AddressType->Id | integer | int64 |\r\n| version | AddressType->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchDeleteAddressType",
        "consumes": [
          "application/vnd.onkey.entitydeletecollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "deletes",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchDeleteAddressTypeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Address Type batch was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/AddressTypes/{id}/Active": {
      "patch": {
        "tags": [
          "Address Type"
        ],
        "summary": "Change the IsActive status for an existing Address Type resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | AddressType->Version | integer | int32 |\r\n| isActive | AddressType->IsActive | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| isActive | Required | True |  |\r\n| isActive | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeAddressTypeIsActive",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Address Type Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/ChangeAddressTypeIsActiveResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/AddressTypes/{id}/PermissionTree": {
      "patch": {
        "tags": [
          "Address Type"
        ],
        "summary": "Change the PermissionTree for an existing Address Type resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | AddressType->Version | integer | int32 |\r\n| permissionTreeId | AddressType->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "ChangeAddressTypePermissionTree",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Address Type Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/ChangeAddressTypePermissionTreeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/AddressTypes/Batch/Active": {
      "patch": {
        "tags": [
          "Address Type"
        ],
        "summary": "Change the IsActive status for a collection of existing Address Type resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | AddressType->Id | integer | int64 |\r\n| version | AddressType->Version | integer | int32 |\r\n| isActive | AddressType->IsActive | boolean |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| isActive | Required | True |  |\r\n| isActive | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeAddressTypeIsActive",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchChangeAddressTypeIsActiveResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/AddressTypes/Batch/PermissionTree": {
      "patch": {
        "tags": [
          "Address Type"
        ],
        "summary": "Change the PermissionTree status for a collection of existing Address Type resources.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | AddressType->Id | integer | int64 |\r\n| version | AddressType->Version | integer | int32 |\r\n| permissionTreeId | AddressType->PermissionTree_Id | integer | int64 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| id | Required | True |  |\r\n| id | Nullable | False |  |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n\r\n",
        "operationId": "BatchChangeAddressTypePermissionTree",
        "consumes": [
          "application/vnd.onkey.entitypatchcollection+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "patches",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/BatchChangeAddressTypePermissionTreeResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          },
          {
            "$ref": "#/parameters/ExecutionMode"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - operation was successfully executed"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/Approvals/{id}": {
      "get": {
        "tags": [
          "Approval"
        ],
        "summary": "Get a Approval resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| createdByUserId | Approval->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Approval->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Approval->CreatedByUser_FullName | string |  |\r\n| createdOn | Approval->CreatedOn | string | date-time |\r\n| modifiedByUserId | Approval->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Approval->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Approval->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Approval->ModifiedOn | string | date-time |\r\n| version | Approval->Version | integer | int32 |\r\n| entitySiteId | Approval->EntitySite_Id | integer | int64 |\r\n| entitySiteCode | Approval->EntitySite_Code | string |  |\r\n| entitySiteDescription | Approval->EntitySite_Description | string |  |\r\n| id | Approval->Id | integer | int64 |\r\n| entityId | Approval->EntityId | integer | int64 |\r\n| entityType | Approval->EntityType | string (Allowed values: [Alarm, NewAlarm, AlarmExpression, AlarmExpressionTask, AlarmAttribute, AlarmDocument, AlarmType, MonitoringPoint, MonitoringPointBoundEvaluationLog, MonitoringPointParameter, MonitoringPointReading, MonitoringPointTrigger, MonitoringPointTriggerExpression, MonitoringPointTriggerExpressionAlarmType, MonitoringPointTriggerExpressionParameter, MonitoringPointTriggerExpressionEvaluation, MonitoringPointTriggerExpressionEvaluationLog, MonitoringPointType, MonitoringPointTypeParameter, MonitoringPointAttribute, MonitoringPointDocument, AuxiliaryAssetTask, AuxiliaryAssetTaskResource, AuxiliaryAssetTaskSpare, AuxiliaryAssetTaskSubTask, RegularAssetComponent, RegularAssetComponentAttribute, RegularAssetComponentDocument, RegularAssetComponentRuleEvaluationFailure, AssetComponent, AssetWarranty, PlaceholderAssetComponent, PlaceholderAssetComponentOptionValue, PlaceholderAssetComponentCondition, PlaceholderAssetMeter, PlaceholderAssetComponentRuleEvaluationFailure, RegularAssetCondition, RegularAssetActiveCondition, AssetFmeca, RegularAssetOptionValue, Asset, RegularAssetAttribute, RegularAssetDocument, RegularAssetFileAttachment, PlaceholderAsset, PlaceholderAssetAttribute, PlaceholderAssetDocument, PlaceholderAssetFileAttachment, PlaceholderAssetRuleEvaluationFailure, PlaceholderAssetResponsibility, PlaceholderAssetCondition, PlaceholderAssetActiveCondition, AssetTask, SetAssetTaskSpareWarehouseEntity, RegularAssetTask, RegularAssetTaskRuleEvaluationFailure, RegularAssetTaskAttribute, RegularAssetTaskAuxiliaryTask, RegularAssetTaskFollowUpTask, RegularAssetTaskFollowUpTaskExpression, RegularAssetTaskSuppressedTask, RegularAssetTaskResource, RegularAssetTaskResourceRuleEvaluationFailure, RegularAssetTaskSpare, RegularAssetTaskSpareRuleEvaluationFailure, RegularAssetTaskSubTask, RegularAssetTaskFileAttachment, AuxiliaryAssetTypeTask, AuxiliaryAssetTypeTaskResource, AuxiliaryAssetTypeTaskSpare, AuxiliaryAssetTypeTaskSubTask, RegularAssetTypeComponent, RegularAssetTypeComponentAttribute, RegularAssetTypeComponentDocument, AssetTypeComponent, PlaceholderAssetTypeComponent, PlaceholderAssetTypeComponentCondition, PlaceholderAssetTypeComponentAttribute, PlaceholderAssetTypeComponentDocument, PlaceholderAssetTypeComponentRuleLink, RegularAssetTypeComponentRuleLink, PlaceholderAssetComponentAttribute, PlaceholderAssetComponentDocument, PlaceholderAssetComponentActiveCondition, AssetTypeFmeca, AssetTypeFunction, AssetFunction, AssetFmecaTask, AssetTypeFmecaTask, AssetTypeFolder, RegularAssetTypeOption, AssetType, PlaceholderAssetType, PlaceholderAssetTypeSpare, PlaceholderAssetTypeAttribute, PlaceholderAssetTypeDocument, PlaceholderAssetTypeResponsibility, PlaceholderAssetTypeRuleLink, RegularAssetTypeTask, RegularAssetTypeTaskAttribute, RegularAssetTypeTaskAuxiliaryTask, RegularAssetTypeTaskCondition, RegularAssetTypeTaskDocument, RegularAssetTypeTaskFollowUpTask, RegularAssetTypeTaskFollowUpTaskExpression, AssetTypeTask, AssetTypeTaskResource, AssetTaskResource, AssetTaskSpare, AssetTypeTaskSpare, RegularAssetTypeTaskResource, RegularAssetTypeTaskRuleLink, RegularAssetTypeTaskSpare, RegularAssetTypeTaskSubTask, RegularAssetTypeTaskSuppressedTask, Condition, ConditionType, Event, FailureCause, FailureCauseType, FailureMechanism, FailureMechanismType, FailureMode, FailureModeType, InPlaceAssetMeter, InPlaceAssetAttribute, InPlaceAssetFileAttachment, InPlaceAssetRuleEvaluationFailure, InPlaceAssetResponsibility, InPlaceAssetSpare, InPlaceAssetType, InPlaceAssetTypeResponsibility, InPlaceAssetTypeRuleLink, InPlaceAssetTypeSpare, InPlaceAsset, Option, OptionCategory, RegularAsset, RegularAssetTaskDocument, RegularAssetMeter, RegularAssetResponsibility, RegularAssetMonitoringPointTrigger, RegularAssetSpare, RegularAssetTaskCondition, RegularAssetType, RegularAssetTypeAttribute, RegularAssetTypeDocument, RegularAssetTypeCondition, PlaceholderAssetTypeCondition, RegularAssetTypeRule, RegularAssetTypeResponsibility, RegularAssetTypeMonitoringPointTrigger, RegularAssetTypeSpare, RepairType, Rule, RuleCategory, RuleOption, StandardTask, StandardTaskSpare, StandardTaskSubTask, StandardTaskResource, StandardTaskAttribute, StandardTaskDocument, TaskImportance, TaskInterval, TaskIntervalType, TaskRollUpPoint, TypeOfWork, RegularAssetTypeTaskSpareRuleLink, InPlaceAssetTypeAttribute, RegularAssetTypeTaskResourceRuleLink, PlaceholderAssetSpare, RegularAssetMonitoringPointTriggerParameter, AssetSpare, AssetTypeSpare, AssetMeter, AssetConsumption, RegularAssetConsumption, PlaceholderAssetConsumption, InPlaceAssetConsumption, WarrantyType, RegularAssetTypeFileAttachment, Meter, MeterAttribute, MeterDocument, MeterReading, PredictedMeterReading, TimeLossCategory, TimeLossReason, TimeLossType, Consumable, AcquisitionStatus, AcquisitionType, DocumentFolder, DocumentRecord, DocumentRecordAttribute, FileAttachment, FileAttachmentCategory, FileAttachmentContentHistory, DocumentRecordFileHistory, Costing, CostingBudget, CostCentre, CostCentreAttribute, CostCentreDocument, CostCentreType, CostElement, CostElementAttribute, CostElementDocument, Currency, BudgetTemplate, BudgetTemplateParameter, FinancialYear, FinancialYearPeriod, GeneralLedger, GeneralLedgerAttribute, GeneralLedgerDocument, CurrencyRate, Budget, BudgetParameter, AddressType, Approval, Attribute, AttributeAllowedValue, Calendar, CalendarDay, CalendarException, CalendarDayHour, Classification, ClassificationAllowedValue, EmailType, Language, OperationalRole, OperationalRoleTemplate, OperationalRoleResource, PhoneNumberType, UserOperationalRole, UserOperationalRoleTemplate, UserOperationalRoleResource, TermsAndCondition, TermsAndConditionVersion, TermsAndConditionOperationalRole, UserTermsAndConditionVersion, Location, LocationAttribute, LocationDocument, LocalisationSet, LocalisationKey, LocalisationTranslation, Phrase, PhraseTranslation, PreconfiguredReason, Site, SiteAttribute, SiteDocument, SiteType, Supplier, SupplierFileAttachment, SupplierAttribute, SupplierDocument, SupplierContactAddress, SupplierContactEmail, SupplierContactPhoneNumber, SupplierResource, SupplierTaxRate, UnitOfMeasurement, SiteResource, SiteContactAddress, SiteContactEmail, SiteContactPhoneNumber, ChangeDataTrigger, ChangeDataTriggerOccurrenceLog, ChangeDataTriggerCriteria, NotificationTemplate, ChangeDataTriggerCriteriaParameter, ChangeDataTriggerNotificationEvent, NotificationTemplateParameter, ChangeDataTriggerNotificationEventAttachment, ChangeDataTriggerNotificationEventAttachmentParameter, RequestType, Category, Commodity, MaterialMaster, MaterialMasterAttribute, MaterialMasterDocument, MaterialMasterBin, MaterialMasterSupplier, MaterialMasterLinkWarehouse, StockItem, StockItemFileAttachment, StockItemAttribute, StockItemDocument, StockItemBin, StockItemSupplier, WarehouseAttribute, Warehouse, WarehouseDocument, Requisition, RequisitionFileAttachment, RequisitionStatus, RequisitionStatusChange, RequisitionStatusAttribute, RequisitionStatusDocument, RequisitionStatusChangeHistory, RequisitionItemTransaction, ApprovalRole, RequisitionAttribute, RequisitionDocument, RequisitionTransaction, RequisitionItem, RequisitionItemFileAttachment, UserSiteApprovalRole, ApprovalWorkflow, ApprovalWorkflowExpression, ApprovalWorkflowExpressionApprovalRole, Competency, Resource, ResourceAttribute, ResourceAddress, ResourceClassification, ResourceCompetency, ResourceDocument, ResourceEmail, ResourcePhoneNumber, ResourceTrade, ResourceTradeCompetency, ResourceTradeFinancialRate, Section, SectionAttribute, SectionDocument, SectionTrade, TradeAttribute, TradeDocument, Trade, TradeCompetency, TradeFinancialRate, ResourceContext, ResourceFileAttachment, AssetImportance, RiskConsequence, RiskConsequenceCategory, RiskModel, RiskModelConsequenceCategory, RiskModelImportance, RiskModelProbability, RiskProbability, WorkOrderImportance, WorkOrderStatus, WorkOrderStatusAttribute, WorkOrderStatusDocument, WorkOrderStatusAllowedChange, WorkOrder, WorkOrderStatusChangeHistory, WorkOrderStatusChange, WorkOrderMerge, WorkOrderSplit, WorkOrderMeter, WorkOrderAttribute, WorkOrderDocument, WorkOrderFileAttachment, WorkOrderTaskFileAttachment, WorkOrderTaskWarranty, WorkOrderTaskSpareFileAttachment, WorkOrderTask, WorkOrderTaskDocument, WorkOrderTaskAdHocCost, WorkOrderMonitoringPoint, WorkOrderTaskMonitoringPoint, WorkOrderTaskSpare, WorkOrderTaskSubTask, WorkOrderTaskResource, WorkOrderTaskResourceUsage, DueTask, DueTaskSuppressor, ProposedWorkOrderBatch, ProposedWorkOrder, ProposedWorkOrderTask, ProposedWorkOrderMeter, WorkOrderMovement, WorkOrderTaskMovement, WorkOrderTaskResourceMovement, WorkOrderTaskSpareMovement, WorkOrderTaskSubTaskMovement, WorkOrderCompleteAllTasksLog, WorkRequest, WorkRequestAttribute, WorkRequestDocument, WorkRequestStatus, WorkRequestStatusChange, WorkRequestStatusChangeHistory, WorkRequestFileAttachment, WorkOrderDowntimeLoss, WorkOrderProgressEvent, WorkOrderProgressEventAllowedChange, WorkOrderProgressLog, WorkOrderWarranty, ServiceLevelAgreementClassification, ServiceLevelAgreement, ServiceLevelAgreementMeasure, WorkOrderServiceLevelAgreement, WorkOrderServiceLevelAgreementMeasure, ServiceLevelAgreementMeasureTrigger, ServiceLevelAgreementMeasureFieldAssignment, PermissionTree, User, UserAttribute, UserDocument, UserAuthentication, SecurityRole, SecurityRolePermission, UserSecurityRole, UserCustomPermission, UserOption, BackgroundTask, BackgroundTaskStep, ScheduledBackgroundTask, ScheduledJob, UserDefinedField, UserDefinedFieldPredefinedValue, SystemOption, SystemOptionPageLimit, SystemOptionWorkOrderStatus, SystemOptionDefaultStandardTask, SystemOptionWorkOrderStatusTypeOfWork, SystemOptionReferenceDataViewPermission, SystemOptionFileAttachmentCategory, SystemOptionFileAttachmentFileType, RecordChange, RecordChangeValue, RecordChangeUser, RecordChangeProperty, NotificationEventOutbox, NotificationEventAttachmentOutbox, NotificationOutbox, NotificationOutboxLog, ChangeDataTriggerCriteriaEvaluation, SystemOptionReportServerEntity, SystemOptionReportServerEntityDefaultReport, TemplateMigrationLog, TemplateMigrationLogIntent, ResourceActionMigrationLog, ImportSchema, ImportFile, UserDefinedQuery, ResourceActionCustomisation, TemplateCustomisation, TemplateResource, ClusterSettings, ClusterIdentityProviderSettings, MessageBrokerHost, MessageBrokerTopic, MessageBrokerTopicConsumer, TenantSettings, TenantChangeDataSubscriptionSettings, TenantIdentityProviderSettings, TenantJobSettings, TenantFileContentStoreLocationSettings, TenantFileContentStoreFileTypeGroupSettings, TenantFileContentStoreFileTypeSettings, ClusterFeatureToggle, TenantFeatureToggle, TenantHealthCheck, TenantMachineHealthCheck, ClusterHealthCheck, ClusterMachineHealthCheck, ClusterCapacitySlot, TenantChangeLogCleanupExpressionSettings, ClusterJobSettings, Ignore]) | enum |\r\n| entityVersion | Approval->EntityVersion | integer | int32 |\r\n| expressionId | Approval->Expression_Id | integer | int64 |\r\n| expressionDescription | Approval->Expression_Description | string |  |\r\n| expressionVersion | Approval->ExpressionVersion | integer | int32 |\r\n| reviewedByUserId | Approval->ReviewedByUser_Id | integer | int64 |\r\n| reviewedByUserCode | Approval->ReviewedByUser_Code | string |  |\r\n| reviewedByUserFullName | Approval->ReviewedByUser_FullName | string |  |\r\n| reviewedOn | Approval->ReviewedOn | string | date-time |\r\n| isHistoric | Approval->IsHistoric | boolean |  |\r\n| isLocked | Approval->IsLocked | boolean |  |\r\n| notes | Approval->Notes | string |  |\r\n| remark | Approval->Remark | string |  |\r\n| roleId | Approval->Role_Id | integer | int64 |\r\n| roleCode | Approval->Role_Code | string |  |\r\n| roleDescription | Approval->Role_Description | string |  |\r\n| sequenceNumber | Approval->SequenceNumber | integer | int32 |\r\n| status | Approval->Status | string (Allowed values: [AwaitingApproval, Approved, Rejected, RoleCountReached]) | enum |\r\n",
        "operationId": "GetApproval",
        "produces": [
          "application/vnd.onkey.entity+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Approval Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Approval",
            "schema": {
              "$ref": "#/definitions/GetApprovalResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/Approvals": {
      "get": {
        "tags": [
          "Approval"
        ],
        "summary": "Get a collection of Approval resources.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | Approval->Id | integer | int64 |\r\n| version | Approval->Version | integer | int32 |\r\n| entityId | Approval->EntityId | integer | int64 |\r\n| entityType | Approval->EntityType | string (Allowed values: [Alarm, NewAlarm, AlarmExpression, AlarmExpressionTask, AlarmAttribute, AlarmDocument, AlarmType, MonitoringPoint, MonitoringPointBoundEvaluationLog, MonitoringPointParameter, MonitoringPointReading, MonitoringPointTrigger, MonitoringPointTriggerExpression, MonitoringPointTriggerExpressionAlarmType, MonitoringPointTriggerExpressionParameter, MonitoringPointTriggerExpressionEvaluation, MonitoringPointTriggerExpressionEvaluationLog, MonitoringPointType, MonitoringPointTypeParameter, MonitoringPointAttribute, MonitoringPointDocument, AuxiliaryAssetTask, AuxiliaryAssetTaskResource, AuxiliaryAssetTaskSpare, AuxiliaryAssetTaskSubTask, RegularAssetComponent, RegularAssetComponentAttribute, RegularAssetComponentDocument, RegularAssetComponentRuleEvaluationFailure, AssetComponent, AssetWarranty, PlaceholderAssetComponent, PlaceholderAssetComponentOptionValue, PlaceholderAssetComponentCondition, PlaceholderAssetMeter, PlaceholderAssetComponentRuleEvaluationFailure, RegularAssetCondition, RegularAssetActiveCondition, AssetFmeca, RegularAssetOptionValue, Asset, RegularAssetAttribute, RegularAssetDocument, RegularAssetFileAttachment, PlaceholderAsset, PlaceholderAssetAttribute, PlaceholderAssetDocument, PlaceholderAssetFileAttachment, PlaceholderAssetRuleEvaluationFailure, PlaceholderAssetResponsibility, PlaceholderAssetCondition, PlaceholderAssetActiveCondition, AssetTask, SetAssetTaskSpareWarehouseEntity, RegularAssetTask, RegularAssetTaskRuleEvaluationFailure, RegularAssetTaskAttribute, RegularAssetTaskAuxiliaryTask, RegularAssetTaskFollowUpTask, RegularAssetTaskFollowUpTaskExpression, RegularAssetTaskSuppressedTask, RegularAssetTaskResource, RegularAssetTaskResourceRuleEvaluationFailure, RegularAssetTaskSpare, RegularAssetTaskSpareRuleEvaluationFailure, RegularAssetTaskSubTask, RegularAssetTaskFileAttachment, AuxiliaryAssetTypeTask, AuxiliaryAssetTypeTaskResource, AuxiliaryAssetTypeTaskSpare, AuxiliaryAssetTypeTaskSubTask, RegularAssetTypeComponent, RegularAssetTypeComponentAttribute, RegularAssetTypeComponentDocument, AssetTypeComponent, PlaceholderAssetTypeComponent, PlaceholderAssetTypeComponentCondition, PlaceholderAssetTypeComponentAttribute, PlaceholderAssetTypeComponentDocument, PlaceholderAssetTypeComponentRuleLink, RegularAssetTypeComponentRuleLink, PlaceholderAssetComponentAttribute, PlaceholderAssetComponentDocument, PlaceholderAssetComponentActiveCondition, AssetTypeFmeca, AssetTypeFunction, AssetFunction, AssetFmecaTask, AssetTypeFmecaTask, AssetTypeFolder, RegularAssetTypeOption, AssetType, PlaceholderAssetType, PlaceholderAssetTypeSpare, PlaceholderAssetTypeAttribute, PlaceholderAssetTypeDocument, PlaceholderAssetTypeResponsibility, PlaceholderAssetTypeRuleLink, RegularAssetTypeTask, RegularAssetTypeTaskAttribute, RegularAssetTypeTaskAuxiliaryTask, RegularAssetTypeTaskCondition, RegularAssetTypeTaskDocument, RegularAssetTypeTaskFollowUpTask, RegularAssetTypeTaskFollowUpTaskExpression, AssetTypeTask, AssetTypeTaskResource, AssetTaskResource, AssetTaskSpare, AssetTypeTaskSpare, RegularAssetTypeTaskResource, RegularAssetTypeTaskRuleLink, RegularAssetTypeTaskSpare, RegularAssetTypeTaskSubTask, RegularAssetTypeTaskSuppressedTask, Condition, ConditionType, Event, FailureCause, FailureCauseType, FailureMechanism, FailureMechanismType, FailureMode, FailureModeType, InPlaceAssetMeter, InPlaceAssetAttribute, InPlaceAssetFileAttachment, InPlaceAssetRuleEvaluationFailure, InPlaceAssetResponsibility, InPlaceAssetSpare, InPlaceAssetType, InPlaceAssetTypeResponsibility, InPlaceAssetTypeRuleLink, InPlaceAssetTypeSpare, InPlaceAsset, Option, OptionCategory, RegularAsset, RegularAssetTaskDocument, RegularAssetMeter, RegularAssetResponsibility, RegularAssetMonitoringPointTrigger, RegularAssetSpare, RegularAssetTaskCondition, RegularAssetType, RegularAssetTypeAttribute, RegularAssetTypeDocument, RegularAssetTypeCondition, PlaceholderAssetTypeCondition, RegularAssetTypeRule, RegularAssetTypeResponsibility, RegularAssetTypeMonitoringPointTrigger, RegularAssetTypeSpare, RepairType, Rule, RuleCategory, RuleOption, StandardTask, StandardTaskSpare, StandardTaskSubTask, StandardTaskResource, StandardTaskAttribute, StandardTaskDocument, TaskImportance, TaskInterval, TaskIntervalType, TaskRollUpPoint, TypeOfWork, RegularAssetTypeTaskSpareRuleLink, InPlaceAssetTypeAttribute, RegularAssetTypeTaskResourceRuleLink, PlaceholderAssetSpare, RegularAssetMonitoringPointTriggerParameter, AssetSpare, AssetTypeSpare, AssetMeter, AssetConsumption, RegularAssetConsumption, PlaceholderAssetConsumption, InPlaceAssetConsumption, WarrantyType, RegularAssetTypeFileAttachment, Meter, MeterAttribute, MeterDocument, MeterReading, PredictedMeterReading, TimeLossCategory, TimeLossReason, TimeLossType, Consumable, AcquisitionStatus, AcquisitionType, DocumentFolder, DocumentRecord, DocumentRecordAttribute, FileAttachment, FileAttachmentCategory, FileAttachmentContentHistory, DocumentRecordFileHistory, Costing, CostingBudget, CostCentre, CostCentreAttribute, CostCentreDocument, CostCentreType, CostElement, CostElementAttribute, CostElementDocument, Currency, BudgetTemplate, BudgetTemplateParameter, FinancialYear, FinancialYearPeriod, GeneralLedger, GeneralLedgerAttribute, GeneralLedgerDocument, CurrencyRate, Budget, BudgetParameter, AddressType, Approval, Attribute, AttributeAllowedValue, Calendar, CalendarDay, CalendarException, CalendarDayHour, Classification, ClassificationAllowedValue, EmailType, Language, OperationalRole, OperationalRoleTemplate, OperationalRoleResource, PhoneNumberType, UserOperationalRole, UserOperationalRoleTemplate, UserOperationalRoleResource, TermsAndCondition, TermsAndConditionVersion, TermsAndConditionOperationalRole, UserTermsAndConditionVersion, Location, LocationAttribute, LocationDocument, LocalisationSet, LocalisationKey, LocalisationTranslation, Phrase, PhraseTranslation, PreconfiguredReason, Site, SiteAttribute, SiteDocument, SiteType, Supplier, SupplierFileAttachment, SupplierAttribute, SupplierDocument, SupplierContactAddress, SupplierContactEmail, SupplierContactPhoneNumber, SupplierResource, SupplierTaxRate, UnitOfMeasurement, SiteResource, SiteContactAddress, SiteContactEmail, SiteContactPhoneNumber, ChangeDataTrigger, ChangeDataTriggerOccurrenceLog, ChangeDataTriggerCriteria, NotificationTemplate, ChangeDataTriggerCriteriaParameter, ChangeDataTriggerNotificationEvent, NotificationTemplateParameter, ChangeDataTriggerNotificationEventAttachment, ChangeDataTriggerNotificationEventAttachmentParameter, RequestType, Category, Commodity, MaterialMaster, MaterialMasterAttribute, MaterialMasterDocument, MaterialMasterBin, MaterialMasterSupplier, MaterialMasterLinkWarehouse, StockItem, StockItemFileAttachment, StockItemAttribute, StockItemDocument, StockItemBin, StockItemSupplier, WarehouseAttribute, Warehouse, WarehouseDocument, Requisition, RequisitionFileAttachment, RequisitionStatus, RequisitionStatusChange, RequisitionStatusAttribute, RequisitionStatusDocument, RequisitionStatusChangeHistory, RequisitionItemTransaction, ApprovalRole, RequisitionAttribute, RequisitionDocument, RequisitionTransaction, RequisitionItem, RequisitionItemFileAttachment, UserSiteApprovalRole, ApprovalWorkflow, ApprovalWorkflowExpression, ApprovalWorkflowExpressionApprovalRole, Competency, Resource, ResourceAttribute, ResourceAddress, ResourceClassification, ResourceCompetency, ResourceDocument, ResourceEmail, ResourcePhoneNumber, ResourceTrade, ResourceTradeCompetency, ResourceTradeFinancialRate, Section, SectionAttribute, SectionDocument, SectionTrade, TradeAttribute, TradeDocument, Trade, TradeCompetency, TradeFinancialRate, ResourceContext, ResourceFileAttachment, AssetImportance, RiskConsequence, RiskConsequenceCategory, RiskModel, RiskModelConsequenceCategory, RiskModelImportance, RiskModelProbability, RiskProbability, WorkOrderImportance, WorkOrderStatus, WorkOrderStatusAttribute, WorkOrderStatusDocument, WorkOrderStatusAllowedChange, WorkOrder, WorkOrderStatusChangeHistory, WorkOrderStatusChange, WorkOrderMerge, WorkOrderSplit, WorkOrderMeter, WorkOrderAttribute, WorkOrderDocument, WorkOrderFileAttachment, WorkOrderTaskFileAttachment, WorkOrderTaskWarranty, WorkOrderTaskSpareFileAttachment, WorkOrderTask, WorkOrderTaskDocument, WorkOrderTaskAdHocCost, WorkOrderMonitoringPoint, WorkOrderTaskMonitoringPoint, WorkOrderTaskSpare, WorkOrderTaskSubTask, WorkOrderTaskResource, WorkOrderTaskResourceUsage, DueTask, DueTaskSuppressor, ProposedWorkOrderBatch, ProposedWorkOrder, ProposedWorkOrderTask, ProposedWorkOrderMeter, WorkOrderMovement, WorkOrderTaskMovement, WorkOrderTaskResourceMovement, WorkOrderTaskSpareMovement, WorkOrderTaskSubTaskMovement, WorkOrderCompleteAllTasksLog, WorkRequest, WorkRequestAttribute, WorkRequestDocument, WorkRequestStatus, WorkRequestStatusChange, WorkRequestStatusChangeHistory, WorkRequestFileAttachment, WorkOrderDowntimeLoss, WorkOrderProgressEvent, WorkOrderProgressEventAllowedChange, WorkOrderProgressLog, WorkOrderWarranty, ServiceLevelAgreementClassification, ServiceLevelAgreement, ServiceLevelAgreementMeasure, WorkOrderServiceLevelAgreement, WorkOrderServiceLevelAgreementMeasure, ServiceLevelAgreementMeasureTrigger, ServiceLevelAgreementMeasureFieldAssignment, PermissionTree, User, UserAttribute, UserDocument, UserAuthentication, SecurityRole, SecurityRolePermission, UserSecurityRole, UserCustomPermission, UserOption, BackgroundTask, BackgroundTaskStep, ScheduledBackgroundTask, ScheduledJob, UserDefinedField, UserDefinedFieldPredefinedValue, SystemOption, SystemOptionPageLimit, SystemOptionWorkOrderStatus, SystemOptionDefaultStandardTask, SystemOptionWorkOrderStatusTypeOfWork, SystemOptionReferenceDataViewPermission, SystemOptionFileAttachmentCategory, SystemOptionFileAttachmentFileType, RecordChange, RecordChangeValue, RecordChangeUser, RecordChangeProperty, NotificationEventOutbox, NotificationEventAttachmentOutbox, NotificationOutbox, NotificationOutboxLog, ChangeDataTriggerCriteriaEvaluation, SystemOptionReportServerEntity, SystemOptionReportServerEntityDefaultReport, TemplateMigrationLog, TemplateMigrationLogIntent, ResourceActionMigrationLog, ImportSchema, ImportFile, UserDefinedQuery, ResourceActionCustomisation, TemplateCustomisation, TemplateResource, ClusterSettings, ClusterIdentityProviderSettings, MessageBrokerHost, MessageBrokerTopic, MessageBrokerTopicConsumer, TenantSettings, TenantChangeDataSubscriptionSettings, TenantIdentityProviderSettings, TenantJobSettings, TenantFileContentStoreLocationSettings, TenantFileContentStoreFileTypeGroupSettings, TenantFileContentStoreFileTypeSettings, ClusterFeatureToggle, TenantFeatureToggle, TenantHealthCheck, TenantMachineHealthCheck, ClusterHealthCheck, ClusterMachineHealthCheck, ClusterCapacitySlot, TenantChangeLogCleanupExpressionSettings, ClusterJobSettings, Ignore]) | enum |\r\n| isLocked | Approval->IsLocked | boolean |  |\r\n| roleCode | Approval->Role_Code | string |  |\r\n| reviewedByUserCode | Approval->ReviewedByUser_Code | string |  |\r\n| reviewedOn | Approval->ReviewedOn | string | date-time |\r\n| remark | Approval->Remark | string |  |\r\n| isHistoric | Approval->IsHistoric | boolean |  |\r\n| status | Approval->Status | string (Allowed values: [AwaitingApproval, Approved, Rejected, RoleCountReached]) | enum |\r\n",
        "operationId": "GetApprovalCollection",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Approval collection",
            "schema": {
              "$ref": "#/definitions/GetApprovalCollectionResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/Approvals/Batch/{ids}": {
      "get": {
        "tags": [
          "Approval"
        ],
        "summary": "Get a collection of Approval resources for the set of id's.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| createdByUserId | Approval->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | Approval->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | Approval->CreatedByUser_FullName | string |  |\r\n| createdOn | Approval->CreatedOn | string | date-time |\r\n| modifiedByUserId | Approval->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | Approval->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | Approval->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | Approval->ModifiedOn | string | date-time |\r\n| version | Approval->Version | integer | int32 |\r\n| entitySiteId | Approval->EntitySite_Id | integer | int64 |\r\n| entitySiteCode | Approval->EntitySite_Code | string |  |\r\n| entitySiteDescription | Approval->EntitySite_Description | string |  |\r\n| id | Approval->Id | integer | int64 |\r\n| entityId | Approval->EntityId | integer | int64 |\r\n| entityType | Approval->EntityType | string (Allowed values: [Alarm, NewAlarm, AlarmExpression, AlarmExpressionTask, AlarmAttribute, AlarmDocument, AlarmType, MonitoringPoint, MonitoringPointBoundEvaluationLog, MonitoringPointParameter, MonitoringPointReading, MonitoringPointTrigger, MonitoringPointTriggerExpression, MonitoringPointTriggerExpressionAlarmType, MonitoringPointTriggerExpressionParameter, MonitoringPointTriggerExpressionEvaluation, MonitoringPointTriggerExpressionEvaluationLog, MonitoringPointType, MonitoringPointTypeParameter, MonitoringPointAttribute, MonitoringPointDocument, AuxiliaryAssetTask, AuxiliaryAssetTaskResource, AuxiliaryAssetTaskSpare, AuxiliaryAssetTaskSubTask, RegularAssetComponent, RegularAssetComponentAttribute, RegularAssetComponentDocument, RegularAssetComponentRuleEvaluationFailure, AssetComponent, AssetWarranty, PlaceholderAssetComponent, PlaceholderAssetComponentOptionValue, PlaceholderAssetComponentCondition, PlaceholderAssetMeter, PlaceholderAssetComponentRuleEvaluationFailure, RegularAssetCondition, RegularAssetActiveCondition, AssetFmeca, RegularAssetOptionValue, Asset, RegularAssetAttribute, RegularAssetDocument, RegularAssetFileAttachment, PlaceholderAsset, PlaceholderAssetAttribute, PlaceholderAssetDocument, PlaceholderAssetFileAttachment, PlaceholderAssetRuleEvaluationFailure, PlaceholderAssetResponsibility, PlaceholderAssetCondition, PlaceholderAssetActiveCondition, AssetTask, SetAssetTaskSpareWarehouseEntity, RegularAssetTask, RegularAssetTaskRuleEvaluationFailure, RegularAssetTaskAttribute, RegularAssetTaskAuxiliaryTask, RegularAssetTaskFollowUpTask, RegularAssetTaskFollowUpTaskExpression, RegularAssetTaskSuppressedTask, RegularAssetTaskResource, RegularAssetTaskResourceRuleEvaluationFailure, RegularAssetTaskSpare, RegularAssetTaskSpareRuleEvaluationFailure, RegularAssetTaskSubTask, RegularAssetTaskFileAttachment, AuxiliaryAssetTypeTask, AuxiliaryAssetTypeTaskResource, AuxiliaryAssetTypeTaskSpare, AuxiliaryAssetTypeTaskSubTask, RegularAssetTypeComponent, RegularAssetTypeComponentAttribute, RegularAssetTypeComponentDocument, AssetTypeComponent, PlaceholderAssetTypeComponent, PlaceholderAssetTypeComponentCondition, PlaceholderAssetTypeComponentAttribute, PlaceholderAssetTypeComponentDocument, PlaceholderAssetTypeComponentRuleLink, RegularAssetTypeComponentRuleLink, PlaceholderAssetComponentAttribute, PlaceholderAssetComponentDocument, PlaceholderAssetComponentActiveCondition, AssetTypeFmeca, AssetTypeFunction, AssetFunction, AssetFmecaTask, AssetTypeFmecaTask, AssetTypeFolder, RegularAssetTypeOption, AssetType, PlaceholderAssetType, PlaceholderAssetTypeSpare, PlaceholderAssetTypeAttribute, PlaceholderAssetTypeDocument, PlaceholderAssetTypeResponsibility, PlaceholderAssetTypeRuleLink, RegularAssetTypeTask, RegularAssetTypeTaskAttribute, RegularAssetTypeTaskAuxiliaryTask, RegularAssetTypeTaskCondition, RegularAssetTypeTaskDocument, RegularAssetTypeTaskFollowUpTask, RegularAssetTypeTaskFollowUpTaskExpression, AssetTypeTask, AssetTypeTaskResource, AssetTaskResource, AssetTaskSpare, AssetTypeTaskSpare, RegularAssetTypeTaskResource, RegularAssetTypeTaskRuleLink, RegularAssetTypeTaskSpare, RegularAssetTypeTaskSubTask, RegularAssetTypeTaskSuppressedTask, Condition, ConditionType, Event, FailureCause, FailureCauseType, FailureMechanism, FailureMechanismType, FailureMode, FailureModeType, InPlaceAssetMeter, InPlaceAssetAttribute, InPlaceAssetFileAttachment, InPlaceAssetRuleEvaluationFailure, InPlaceAssetResponsibility, InPlaceAssetSpare, InPlaceAssetType, InPlaceAssetTypeResponsibility, InPlaceAssetTypeRuleLink, InPlaceAssetTypeSpare, InPlaceAsset, Option, OptionCategory, RegularAsset, RegularAssetTaskDocument, RegularAssetMeter, RegularAssetResponsibility, RegularAssetMonitoringPointTrigger, RegularAssetSpare, RegularAssetTaskCondition, RegularAssetType, RegularAssetTypeAttribute, RegularAssetTypeDocument, RegularAssetTypeCondition, PlaceholderAssetTypeCondition, RegularAssetTypeRule, RegularAssetTypeResponsibility, RegularAssetTypeMonitoringPointTrigger, RegularAssetTypeSpare, RepairType, Rule, RuleCategory, RuleOption, StandardTask, StandardTaskSpare, StandardTaskSubTask, StandardTaskResource, StandardTaskAttribute, StandardTaskDocument, TaskImportance, TaskInterval, TaskIntervalType, TaskRollUpPoint, TypeOfWork, RegularAssetTypeTaskSpareRuleLink, InPlaceAssetTypeAttribute, RegularAssetTypeTaskResourceRuleLink, PlaceholderAssetSpare, RegularAssetMonitoringPointTriggerParameter, AssetSpare, AssetTypeSpare, AssetMeter, AssetConsumption, RegularAssetConsumption, PlaceholderAssetConsumption, InPlaceAssetConsumption, WarrantyType, RegularAssetTypeFileAttachment, Meter, MeterAttribute, MeterDocument, MeterReading, PredictedMeterReading, TimeLossCategory, TimeLossReason, TimeLossType, Consumable, AcquisitionStatus, AcquisitionType, DocumentFolder, DocumentRecord, DocumentRecordAttribute, FileAttachment, FileAttachmentCategory, FileAttachmentContentHistory, DocumentRecordFileHistory, Costing, CostingBudget, CostCentre, CostCentreAttribute, CostCentreDocument, CostCentreType, CostElement, CostElementAttribute, CostElementDocument, Currency, BudgetTemplate, BudgetTemplateParameter, FinancialYear, FinancialYearPeriod, GeneralLedger, GeneralLedgerAttribute, GeneralLedgerDocument, CurrencyRate, Budget, BudgetParameter, AddressType, Approval, Attribute, AttributeAllowedValue, Calendar, CalendarDay, CalendarException, CalendarDayHour, Classification, ClassificationAllowedValue, EmailType, Language, OperationalRole, OperationalRoleTemplate, OperationalRoleResource, PhoneNumberType, UserOperationalRole, UserOperationalRoleTemplate, UserOperationalRoleResource, TermsAndCondition, TermsAndConditionVersion, TermsAndConditionOperationalRole, UserTermsAndConditionVersion, Location, LocationAttribute, LocationDocument, LocalisationSet, LocalisationKey, LocalisationTranslation, Phrase, PhraseTranslation, PreconfiguredReason, Site, SiteAttribute, SiteDocument, SiteType, Supplier, SupplierFileAttachment, SupplierAttribute, SupplierDocument, SupplierContactAddress, SupplierContactEmail, SupplierContactPhoneNumber, SupplierResource, SupplierTaxRate, UnitOfMeasurement, SiteResource, SiteContactAddress, SiteContactEmail, SiteContactPhoneNumber, ChangeDataTrigger, ChangeDataTriggerOccurrenceLog, ChangeDataTriggerCriteria, NotificationTemplate, ChangeDataTriggerCriteriaParameter, ChangeDataTriggerNotificationEvent, NotificationTemplateParameter, ChangeDataTriggerNotificationEventAttachment, ChangeDataTriggerNotificationEventAttachmentParameter, RequestType, Category, Commodity, MaterialMaster, MaterialMasterAttribute, MaterialMasterDocument, MaterialMasterBin, MaterialMasterSupplier, MaterialMasterLinkWarehouse, StockItem, StockItemFileAttachment, StockItemAttribute, StockItemDocument, StockItemBin, StockItemSupplier, WarehouseAttribute, Warehouse, WarehouseDocument, Requisition, RequisitionFileAttachment, RequisitionStatus, RequisitionStatusChange, RequisitionStatusAttribute, RequisitionStatusDocument, RequisitionStatusChangeHistory, RequisitionItemTransaction, ApprovalRole, RequisitionAttribute, RequisitionDocument, RequisitionTransaction, RequisitionItem, RequisitionItemFileAttachment, UserSiteApprovalRole, ApprovalWorkflow, ApprovalWorkflowExpression, ApprovalWorkflowExpressionApprovalRole, Competency, Resource, ResourceAttribute, ResourceAddress, ResourceClassification, ResourceCompetency, ResourceDocument, ResourceEmail, ResourcePhoneNumber, ResourceTrade, ResourceTradeCompetency, ResourceTradeFinancialRate, Section, SectionAttribute, SectionDocument, SectionTrade, TradeAttribute, TradeDocument, Trade, TradeCompetency, TradeFinancialRate, ResourceContext, ResourceFileAttachment, AssetImportance, RiskConsequence, RiskConsequenceCategory, RiskModel, RiskModelConsequenceCategory, RiskModelImportance, RiskModelProbability, RiskProbability, WorkOrderImportance, WorkOrderStatus, WorkOrderStatusAttribute, WorkOrderStatusDocument, WorkOrderStatusAllowedChange, WorkOrder, WorkOrderStatusChangeHistory, WorkOrderStatusChange, WorkOrderMerge, WorkOrderSplit, WorkOrderMeter, WorkOrderAttribute, WorkOrderDocument, WorkOrderFileAttachment, WorkOrderTaskFileAttachment, WorkOrderTaskWarranty, WorkOrderTaskSpareFileAttachment, WorkOrderTask, WorkOrderTaskDocument, WorkOrderTaskAdHocCost, WorkOrderMonitoringPoint, WorkOrderTaskMonitoringPoint, WorkOrderTaskSpare, WorkOrderTaskSubTask, WorkOrderTaskResource, WorkOrderTaskResourceUsage, DueTask, DueTaskSuppressor, ProposedWorkOrderBatch, ProposedWorkOrder, ProposedWorkOrderTask, ProposedWorkOrderMeter, WorkOrderMovement, WorkOrderTaskMovement, WorkOrderTaskResourceMovement, WorkOrderTaskSpareMovement, WorkOrderTaskSubTaskMovement, WorkOrderCompleteAllTasksLog, WorkRequest, WorkRequestAttribute, WorkRequestDocument, WorkRequestStatus, WorkRequestStatusChange, WorkRequestStatusChangeHistory, WorkRequestFileAttachment, WorkOrderDowntimeLoss, WorkOrderProgressEvent, WorkOrderProgressEventAllowedChange, WorkOrderProgressLog, WorkOrderWarranty, ServiceLevelAgreementClassification, ServiceLevelAgreement, ServiceLevelAgreementMeasure, WorkOrderServiceLevelAgreement, WorkOrderServiceLevelAgreementMeasure, ServiceLevelAgreementMeasureTrigger, ServiceLevelAgreementMeasureFieldAssignment, PermissionTree, User, UserAttribute, UserDocument, UserAuthentication, SecurityRole, SecurityRolePermission, UserSecurityRole, UserCustomPermission, UserOption, BackgroundTask, BackgroundTaskStep, ScheduledBackgroundTask, ScheduledJob, UserDefinedField, UserDefinedFieldPredefinedValue, SystemOption, SystemOptionPageLimit, SystemOptionWorkOrderStatus, SystemOptionDefaultStandardTask, SystemOptionWorkOrderStatusTypeOfWork, SystemOptionReferenceDataViewPermission, SystemOptionFileAttachmentCategory, SystemOptionFileAttachmentFileType, RecordChange, RecordChangeValue, RecordChangeUser, RecordChangeProperty, NotificationEventOutbox, NotificationEventAttachmentOutbox, NotificationOutbox, NotificationOutboxLog, ChangeDataTriggerCriteriaEvaluation, SystemOptionReportServerEntity, SystemOptionReportServerEntityDefaultReport, TemplateMigrationLog, TemplateMigrationLogIntent, ResourceActionMigrationLog, ImportSchema, ImportFile, UserDefinedQuery, ResourceActionCustomisation, TemplateCustomisation, TemplateResource, ClusterSettings, ClusterIdentityProviderSettings, MessageBrokerHost, MessageBrokerTopic, MessageBrokerTopicConsumer, TenantSettings, TenantChangeDataSubscriptionSettings, TenantIdentityProviderSettings, TenantJobSettings, TenantFileContentStoreLocationSettings, TenantFileContentStoreFileTypeGroupSettings, TenantFileContentStoreFileTypeSettings, ClusterFeatureToggle, TenantFeatureToggle, TenantHealthCheck, TenantMachineHealthCheck, ClusterHealthCheck, ClusterMachineHealthCheck, ClusterCapacitySlot, TenantChangeLogCleanupExpressionSettings, ClusterJobSettings, Ignore]) | enum |\r\n| entityVersion | Approval->EntityVersion | integer | int32 |\r\n| expressionId | Approval->Expression_Id | integer | int64 |\r\n| expressionDescription | Approval->Expression_Description | string |  |\r\n| expressionVersion | Approval->ExpressionVersion | integer | int32 |\r\n| reviewedByUserId | Approval->ReviewedByUser_Id | integer | int64 |\r\n| reviewedByUserCode | Approval->ReviewedByUser_Code | string |  |\r\n| reviewedByUserFullName | Approval->ReviewedByUser_FullName | string |  |\r\n| reviewedOn | Approval->ReviewedOn | string | date-time |\r\n| isHistoric | Approval->IsHistoric | boolean |  |\r\n| isLocked | Approval->IsLocked | boolean |  |\r\n| notes | Approval->Notes | string |  |\r\n| remark | Approval->Remark | string |  |\r\n| roleId | Approval->Role_Id | integer | int64 |\r\n| roleCode | Approval->Role_Code | string |  |\r\n| roleDescription | Approval->Role_Description | string |  |\r\n| sequenceNumber | Approval->SequenceNumber | integer | int32 |\r\n| status | Approval->Status | string (Allowed values: [AwaitingApproval, Approved, Rejected, RoleCountReached]) | enum |\r\n",
        "operationId": "BatchGetApproval",
        "produces": [
          "application/vnd.onkey.entitycollection+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "array",
            "name": "ids",
            "in": "path",
            "required": true,
            "description": "A comma separated list of Approval id's (eg. 1585760985950002,1585760985950003)",
            "collectionFormat": "csv",
            "x-nullable": false,
            "items": {
              "type": "integer",
              "format": "int64"
            }
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Approval collection",
            "schema": {
              "$ref": "#/definitions/BatchGetApprovalResourceAction"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/ApprovalRoles/{id}": {
      "get": {
        "tags": [
          "Approval Role"
        ],
        "summary": "Get a Approval Role resource.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| code | ApprovalRole->Code | string |  |\r\n| isActive | ApprovalRole->IsActive | boolean |  |\r\n| createdByUserId | ApprovalRole->CreatedByUser_Id | integer | int64 |\r\n| createdByUserCode | ApprovalRole->CreatedByUser_Code | string |  |\r\n| createdByUserFullName | ApprovalRole->CreatedByUser_FullName | string |  |\r\n| createdOn | ApprovalRole->CreatedOn | string | date-time |\r\n| modifiedByUserId | ApprovalRole->ModifiedByUser_Id | integer | int64 |\r\n| modifiedByUserCode | ApprovalRole->ModifiedByUser_Code | string |  |\r\n| modifiedByUserFullName | ApprovalRole->ModifiedByUser_FullName | string |  |\r\n| modifiedOn | ApprovalRole->ModifiedOn | string | date-time |\r\n| version | ApprovalRole->Version | integer | int32 |\r\n| permissionTreeId | ApprovalRole->PermissionTree_Id | integer | int64 |\r\n| permissionTreeCode | ApprovalRole->PermissionTree_Code | string |  |\r\n| permissionTreeDescription | ApprovalRole->PermissionTree_Description | string |  |\r\n| id | ApprovalRole->Id | integer | int64 |\r\n| description | ApprovalRole->Description | string |  |\r\n| notes | ApprovalRole->Notes | string |  |\r\n| sequenceNumber | ApprovalRole->SequenceNumber | integer | int32 |\r\n",
        "operationId": "GetApprovalRole",
        "produces": [
          "application/vnd.onkey.entity+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Approval Role Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "$ref": "#/parameters/Select"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains Approval Role",
            "schema": {
              "$ref": "#/definitions/GetApprovalRoleResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "patch": {
        "tags": [
          "Approval Role"
        ],
        "summary": "Update an existing Approval Role resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | ApprovalRole->Version | integer | int32 |\r\n| code | ApprovalRole->Code | string |  |\r\n| description | ApprovalRole->Description | string |  |\r\n| sequenceNumber | ApprovalRole->SequenceNumber | integer | int32 |\r\n| notes | ApprovalRole->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n\r\n",
        "operationId": "UpdateApprovalRole",
        "consumes": [
          "application/vnd.onkey.entitypatch+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Approval Role Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "patch",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/UpdateApprovalRoleResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Approval Role was successfully updated"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "delete": {
        "tags": [
          "Approval Role"
        ],
        "summary": "Delete an existing Approval Role resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | ApprovalRole->Version | integer | int32 |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| version | Required | True |  |\r\n| version | Nullable | False |  |\r\n\r\n",
        "operationId": "DeleteApprovalRole",
        "consumes": [
          "application/vnd.onkey.entitydelete+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "type": "integer",
            "name": "id",
            "in": "path",
            "required": true,
            "description": "Approval Role Id",
            "format": "int64",
            "x-nullable": false
          },
          {
            "name": "delete",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/DeleteApprovalRoleResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "204": {
            "x-nullable": true,
            "description": "Success response - Approval Role was successfully deleted"
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/ApprovalRoles": {
      "get": {
        "tags": [
          "Approval Role"
        ],
        "summary": "Get a collection of Approval Role resources.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| version | ApprovalRole->Version | integer | int32 |\r\n| id | ApprovalRole->Id | integer | int64 |\r\n| code | ApprovalRole->Code | string |  |\r\n| description | ApprovalRole->Description | string |  |\r\n| permissionTreeCode | ApprovalRole->PermissionTree_Code | string |  |\r\n| sequenceNumber | ApprovalRole->SequenceNumber | integer | int32 |\r\n| notes | ApprovalRole->Notes | string |  |\r\n| createdOn | ApprovalRole->CreatedOn | string | date-time |\r\n| modifiedOn | ApprovalRole->ModifiedOn | string | date-time |\r\n",
        "operationId": "GetApprovalRoleCollection",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable Approval Role collection",
            "schema": {
              "$ref": "#/definitions/GetApprovalRoleCollectionResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      },
      "post": {
        "tags": [
          "Approval Role"
        ],
        "summary": "Create a new Approval Role resource.",
        "description": "### <a name='request'></a> Request Body\r\n#### Payload\r\n\r\nThe request body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| permissionTreeId | ApprovalRole->PermissionTree_Id | integer | int64 |\r\n| code | ApprovalRole->Code | string |  |\r\n| description | ApprovalRole->Description | string |  |\r\n| sequenceNumber | ApprovalRole->SequenceNumber | integer | int32 |\r\n| notes | ApprovalRole->Notes | string |  |\r\n\r\n#### Business Rules\r\n\r\nThe following business rules apply to the properties:\r\n\r\n| Property | Rule | Value | Condition |\r\n| ---- | :----: | :----: | :----: |\r\n| permissionTreeId | Required | True |  |\r\n| permissionTreeId | Nullable | False |  |\r\n| code | Required | True |  |\r\n| code | Nullable | False |  |\r\n| code | Min Length | >= 1 chars|  |\r\n| code | Max Length | <= 50 chars|  |\r\n| description | Required | True |  |\r\n| description | Nullable | False |  |\r\n| description | Min Length | >= 1 chars|  |\r\n| description | Max Length | <= 100 chars|  |\r\n\r\n",
        "operationId": "CreateApprovalRole",
        "consumes": [
          "application/vnd.onkey.entity+json"
        ],
        "produces": [
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "name": "post",
            "in": "body",
            "required": true,
            "description": "Request Body content",
            "schema": {
              "$ref": "#/definitions/CreateApprovalRoleResourceActionRequest"
            }
          },
          {
            "$ref": "#/parameters/Async"
          },
          {
            "$ref": "#/parameters/AsyncDescription"
          },
          {
            "$ref": "#/parameters/Schedule"
          }
        ],
        "responses": {
          "201": {
            "x-nullable": true,
            "description": "Success response - resource was successfully created",
            "headers": {
              "OnKey-Resource-Id": {
                "type": "integer",
                "description": "Id of the resource created",
                "format": "Int64"
              },
              "OnKey-Resource-Location": {
                "type": "string",
                "description": "Uri to fetch the created resource"
              }
            }
          },
          "202": {
            "description": "Request was successfully registered for asynchronous execution using a Background Task",
            "headers": {
              "OnKey-Request-Id": {
                "type": "integer",
                "description": "Request id for the Background Task created",
                "format": "Int64"
              },
              "OnKey-Request-Location": {
                "type": "string",
                "description": "URI to poll for the asynchronous execution status of the request"
              }
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/ApprovalRoles/Lookups/LookupApprovalRoleChangePermissionTree": {
      "get": {
        "tags": [
          "Approval Role"
        ],
        "summary": "Lookup the permission set for changing the Approval Role.",
        "description": "### <a name='response'></a> Response Body\r\n#### Payload\r\n\r\nThe response body can contain the following properties:\r\n\r\n| Name | Path | Type | Format |\r\n| ---- | ---- | ---- | ---- |\r\n| id | PermissionTree->Id | integer | int64 |\r\n| code | PermissionTree->Code | string |  |\r\n| description | PermissionTree->Description | string |  |\r\n| idPermissionTreeMatrixIdTreeLevel | PermissionTree->*Id.PermissionTreeMatrix.Id_TreeLevel | integer | int32 |\r\n| parentPermissionTreeId | PermissionTree->ParentPermissionTree_Id | integer | int64 |\r\n",
        "operationId": "LookupApprovalRoleChangePermissionTree",
        "produces": [
          "application/vnd.onkey.entitycollectionpage+json",
          "application/vnd.onkey.notification+json"
        ],
        "parameters": [
          {
            "$ref": "#/parameters/Select"
          },
          {
            "$ref": "#/parameters/Filter"
          },
          {
            "$ref": "#/parameters/Param"
          },
          {
            "$ref": "#/parameters/Top"
          },
          {
            "$ref": "#/parameters/Skip"
          },
          {
            "$ref": "#/parameters/OrderBy"
          }
        ],
        "responses": {
          "200": {
            "x-nullable": true,
            "description": "Success response - body contains pageable  collection",
            "schema": {
              "$ref": "#/definitions/ApprovalRoleChangePermissionTreeLookupResourceActionResponse"
            }
          },
          "default": {
            "x-nullable": true,
            "description": "Error response - operation failed"
          }
        }
      }
    },
    "/Modules/GEN/ApprovalRoles/Lookups/LookupApprovalRoleInsertPermissionTree": {
      "get": {
        "tags": [
          "Approval Role"
        ],
        "summary": "Lookup the permission set for creating the Approval Role.",
[...]
